"""
web2ldap plugin classes for LDAP-based naming service (ldapns.schema)

$Id: ldapns.py,v 1.1 2009/06/23 11:43:55 michael Exp $
"""

from w2lapp.schema.syntaxes import LDAPSyntax,SelectList,syntax_registry


class AuthorizedService(SelectList):
  """
  See http://www.iana.org/assignments/gssapi-service-names
  """
  oid = 'AuthorizedService-oid'
  desc = 'IANA GSS-API authorized service name'

  attr_value_dict = {
    '':'',
    'rcmd':'remote command/rlogin/telnet',
    'imap':'mailstore access/IMAP4',
    'pop':'maildrop access/POP3',
    'acap':'remote configuration access/ACAP',
    'nfs':'distributed file system protocol (NFS)',
    'ftp':'file transfer/FTP/TFTP',
    'ldap':'Lightweight Directory Access Protocol (LDAP)',
    'smtp':'message transfer/SMTP',
    'beep':'Blocks Extensible Exchange Protocol (BEEP)',
    'mupdate':'Mailbox Update (MUPDATE) Protocol',
    'sacred':'Secure Available Credentials (SACRED) Protocol',
    'sieve':'ManageSieve Protocol',
    'xmpp':'Extensible Messaging and Presence Protocol (XMPP)',
    'nntp':'Network News Transfer Protocol (NNTP)',
  }


syntax_registry.registerAttrType(
  AuthorizedService.oid,[
    '1.3.6.1.4.1.5322.17.2.1', # authorizedService
  ]
)


# Register all syntax classes in this module
for name in dir():
  syntax_registry.registerSyntaxClass(eval(name))

