"""
web2ldap plugin classes for PGP key server

$Id: pgpkeysrv.py,v 1.2 2008/09/24 08:20:27 michael Exp $
"""

import re
from w2lapp.core import utf2display
from w2lapp.schema.syntaxes import Binary,MultilineText,syntax_registry


class PgpKey(MultilineText):
  oid = 'PgpKey-oid'
  desc = 'PGP key'
  reObj=re.compile('^-----BEGIN PGP PUBLIC KEY BLOCK-----[a-zA-Z0-9+/]-----END PGP PUBLIC KEY BLOCK-----$',re.S+re.M)
  lineSep = '\n'
  mimeType = 'application/pgp-keys'
  cols = 64

  def displayValue(self,valueindex=0,commandbutton=0):
    lines = [
      utf2display(self._form.accept_charset,l)
      for l in self._split_lines(self.attrValue)
    ]
    return '<code>%s</code>' % '<br>'.join(lines)


syntax_registry.registerAttrType(
  PgpKey.oid,[
    '1.3.6.1.4.1.3401.8.2.11', # pgpKey
  ]
)


# Register all syntax classes in this module
for symbol_name in dir():
  syntax_registry.registerSyntaxClass(eval(symbol_name))
