"""
web2ldap plugin classes for attributes defined for pilotPerson

see also RFC1274

$Id: pilotperson.py,v 1.2 2009/07/17 22:20:32 michael Exp $
"""

from w2lapp.schema.syntaxes import SelectList,syntax_registry


class MailPreferenceOption(SelectList):
  oid = 'MailPreferenceOption-oid'
  desc = 'RFC1274: mail preference option syntax'

  attr_value_dict = {
    '':'',
    '0':'no-list-inclusion',
    '1':'any-list-inclusion',
    '2':'professional-list-inclusion',
  }

syntax_registry.registerAttrType(
  MailPreferenceOption.oid,[
    '0.9.2342.19200300.100.1.47', # mailPreferenceOption (defined for pilotPerson)
  ]
)

# Register all syntax classes in this module
for name in dir():
  syntax_registry.registerSyntaxClass(eval(name))

