"""
web2ldap plugin classes for attributes defined for subentries (see RFC 3672)

$Id: subentries.py,v 1.1 2008/08/25 10:13:00 michael Exp $
"""

from w2lapp.schema.syntaxes import LDAPSyntax,SelectList,syntax_registry


class AdministrativeRole(SelectList):
  oid = 'AdministrativeRole-oid'
  desc = 'RFC 3672: indicate that the associated administrative area is concerned with one or more administrative roles'

  attr_value_dict = {
    '':'',
    '2.5.23.1':'autonomousArea',
    '2.5.23.2':'accessControlSpecificArea',
    '2.5.23.3':'accessControlInnerArea',
    '2.5.23.4':'subschemaAdminSpecificArea',
    '2.5.23.5':'collectiveAttributeSpecificArea',
    '2.5.23.6':'collectiveAttributeInnerArea',
  }

syntax_registry.registerAttrType(
  AdministrativeRole.oid,[
    '2.5.18.5', # administrativeRole (defined in RFC 3672)
  ]
)


# Register all syntax classes in this module
for name in dir():
  syntax_registry.registerSyntaxClass(eval(name))

